/** Programm zur Verwaltung von Personen
  * @author Vitus Lorenz-Meyer
  * @version 1.2a vom 20.4 2002
  */
/**Klasse, die eine einzelne Person reprsentiert */
class Person_voll extends Person{
	protected String strae, wohnort;
	protected int plz, hausnummer;
	/** leerer Konstruktor */
	public Person_voll(){
		
		strae=wohnort=null;
		plz=hausnummer=0;
	}
	/** Konstruktor unter Angabe aller Daten 
	*@throws IllegalArgumentException wenn Hausnummer oder PLZ nicht konform sind
	*/
	public Person_voll(String n, String vn, String s, int hau, int p, String w){
		
		super(n,vn);
		if (hau<0)
			throw new IllegalArgumentException("Hausnummer muss pos. ganze Zahl sein!");
		if (p<0 || p>99999)
			throw new IllegalArgumentException("PLZ muss pos. ganze Zahl <100.000 sein!");
		
		strae=s;
		wohnort=w;
		plz=p;
		hausnummer=hau;		
	}
	/** liefert einen String in Adressform */
	public String toString(){
		return (String)("\t" + vorname + " " + name + "\r\n\t" + strae + " " + hausnummer + "\r\n\t"
		+ plz + " " + wohnort + "\r\n");
	}
	
	
}