import java.io.*;
import java.util.*;


class Polynom implements Serializable {
	
	public Vector vars;
	private static int level=0;
	static float[][] float1= {{2,7},{1,6},{1,5},{3,4},{-2,3},{-1,2},{-3,1},{-1,0}};
	static float[][] float2= {{2,5},{-1,4},{3,2},{-5,1},{1,0}};
	static float[][] float3= {{10,4},{-1,3},{-2,2},{4,1},{-2,0}};
	static float[][] float4= {{3,3},{-1,0}};
	static float[][] float5= {{1,2},{-1,0}};
	static float[][] float6= {{1,1},{-1,0}};
	
	
	public static void main(String[] args){
		if (args.length>0) level=new Integer(args[0]).intValue();
		System.out.println("entering debug-level "+level+":\r\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
		
		Polynom p1 = new Polynom(float1);
		Polynom p2 = new Polynom(float2);
		Polynom p3 = new Polynom(float3);
		Polynom p4 = new Polynom(float4);
		Polynom p5 = new Polynom(float5);
		Polynom p6 = new Polynom(float6);
		
//		System.out.println(p1);
//		System.out.println(p2);
//		Polynom[] t=p1.gcd(p2);
		//System.out.println(t[0].trim()+" ,Rest: "+t[1].trim());
		//System.out.println((p1.sub(t[0].mult(p2))).trim());
//		System.out.println("Ergebnis: "+t[0]);
		System.out.println("a.d/dx.int: "+p1.integr().diff());
		System.out.println("b.d/dx.int: "+p2.integr().diff());
		System.out.println("a bei 0:"+p1.eval(0));
		System.out.println("a bei 1:"+p1.eval(1));
		System.out.println("a bei 5:"+p1.eval(5));
		
		/*
		System.out.println(p3);
		System.out.println(p4);
		t=p3.div(p4);
		//System.out.println(t[0].trim()+" ,Rest: "+t[1].trim());
		//System.out.println((p1.sub(t[0].mult(p2))).trim());
		System.out.println("Ergebnis: "+t[0]);
		System.out.println("Rest: "+t[1]);
		*/
	}
	private static void debug(int l,String t){
		if (level>=l) System.out.println(t);
	}
	public Polynom(){
		vars = new Vector();
	}
	public Polynom(Variable[] v){
		this();
		for (int i=0;i<v.length;i++) 
			vars.addElement(v[i]);
	}
	public Polynom(float[][] v){
		this();
		for (int i=0;i<v.length;i++)
			vars.addElement(new Variable(((float)v[i][0]),((int)v[i][1])));
	}
	
	public Polynom(Variable v){
		this();
		vars.addElement(v);
	}
	public Polynom add(Variable v){
		return this.add(new Polynom(v));
	}
	public Polynom mult(Variable v){
		return this.mult(new Polynom(v));
	}
	
	public Polynom trim(){	//entfernt alle Koeff., die null sind(==0) und sortiert vars
		debug(4,"------trimming----"+this+"-----");
				
		Variable a,b=null,c=new Variable(0,-1);
		Vector ret=new Vector();
		boolean unsorted=false;
						
			Iterator it=vars.iterator();
			while(it.hasNext()){
				
				a=(Variable)it.next();
				debug(4,"iteriere, a="+a+",b="+b);
				if ((b!=null)&&(b.exp<a.exp)) unsorted=true;	//muss sortiert werden
				if ((a.coeff) == 0) it.remove();
				else b=a;
			}
		
		debug(4,"trimmed,"+this+",unsorted="+unsorted);
		//und weils cool kommt, sortiert trim auch gleich noch die restlichen Koeff. nach der Gre...
		if (unsorted){
			Polynom temp=(Polynom)this.CloneSer();
			do{
				b=c;	//c is nur test-var, um sie gegen a zu testen (scheiss referenzen!)
				debug(4,"Enumerate ber temp="+temp);
				it=temp.vars.iterator();
				while(it.hasNext()){
					a=(Variable)it.next();
					if (a.exp > b.exp)
						b=a;
				}
				//b zeigt nun auf das grte Element
				debug(4,"add b="+b);
				ret.addElement(b);	//hoffentlich sortiet einfgen in ret
				temp.vars.remove(b);		//und aus temp rauslschen
					
			}while (!temp.vars.isEmpty());	//solange temp nich leer
			vars=ret;
			debug(4,"sorted Poly="+this);
		}
		debug(4,"--------------end trimming----------------------\r\n");
		return this;
	}
	public Polynom add(Polynom p){
		
		Polynom ret=(Polynom)this.CloneSer();
		Variable a=null,b=null;
		if (vars.isEmpty()) ret.vars=p.vars;
		else{
			for (Enumeration el=p.vars.elements(); el.hasMoreElements(); ){
				a=(Variable)el.nextElement();
				if ((b=ret.findExp(a.exp))!=null) //findet denselben Exponenten
					b.addmy(a);		//und benutzt addmy, das das Objekt selber verndert, und nicht ein neues zurckgibt
				else 
					ret.vars.addElement(a);	//falls Exp nicht vorhanden, wird hinzugefgt
				
			}
		}
		return ret.trim();
	}
	public Polynom sub(Polynom p){
		Polynom t=new Polynom();
		
		Variable a=null;
		for (Enumeration el=p.vars.elements(); el.hasMoreElements(); ){
			a=(Variable)el.nextElement();
			t=t.add(new Variable(-a.coeff,a.exp));		//dreht alle Koeff. von b um
			
		}
		return (this.add(t)).trim();			//und addiert dann t
	}
	public Polynom mult(Polynom p){
		Polynom ret=new Polynom();
		
		Variable a=null,b=null;
		
		if (!vars.isEmpty())
		{
			for (Enumeration el=vars.elements(); el.hasMoreElements(); ){
		
				a=(Variable)el.nextElement();
				for (Enumeration ek=p.vars.elements(); ek.hasMoreElements(); ){	//jede Variable von a und von b wird...
		
					b=(Variable)ek.nextElement();
					ret=ret.add(a.mult(b));	//miteinander malgenommen und zum Ergebnis addiert
						
				}
				
			}
		}
		return ret.trim();
	}	
	public Polynom[] div(Polynom p){
		Polynom ret=new Polynom();
		Polynom[] tur = new Polynom[2];
		int i=0;
		debug(2,"________________________________________________________________________\r\nberechne "+this+":"+p+"=");
				
		Polynom f=(Polynom)this.CloneSer();
		Variable a=null;
		if (p.zero()) throw new RuntimeException("divide by zero");
		else if (!vars.isEmpty()){
			//solange deg(f) (wird verndert) noch >= deg(b)... 
			while ((!f.zero())&&((Variable)f.vars.firstElement()).exp>=((Variable)p.vars.firstElement()).exp){
				i++;
				a=((Variable)f.vars.firstElement()).div( (Variable)p.vars.firstElement() );	//ErgebnisVar ist der ersten beiden Vars von f,b
				f=f.sub(p.mult(a));	//wird jetzt vom Rest abgezogen
				ret=ret.add(a);		//und zum Ergebnis addiert
				//if (Math.round(((Variable)f.vars.elementAt(0)).coeff))==0) f.vars.remove(f.vars.elementAt(0));
				//kommt nie ganz hin, also zur Sicherheit...
				debug(2,"Zwischenerg nach "+i+". Schritt:\r\n\ta="+a+", return="+ret+", Restpolynom="+f+"\r\n");
				
				
			}
			tur[1]=f.trim();//[1]= Rest
		
		}
		tur[0]=ret.trim();	//[0] ist das Ergebnis
		debug(2,"damit Ergebnis="+ret+"\tRest="+f+"\r\n________________________________________________________________________\r\n");
				
		return tur;
	}		
				
	public Variable findExp(int x){
		Variable a=null;
		//System.out.println("finding exp to: "+x);
     		Enumeration el=vars.elements();
     		while (el.hasMoreElements() && (!((a=(Variable)el.nextElement()).exp==x))) ;
			
     		return (a.exp==x?a:null);
  	}
  	public Polynom[] gcd(Polynom p){
		Polynom a = (Polynom)this.CloneSer();
		Polynom b = (Polynom)p.CloneSer();
		Polynom s = new Polynom(new Variable(1,0));
		Polynom v = new Polynom(new Variable(1,0));
		Polynom u = new Polynom();
		Polynom t = new Polynom();
		Polynom[] q=null;
		Polynom[] ret= new Polynom[3];
		Polynom temp;int i=0;
		
		while (!b.zero()){
		try{
			
		
			q=a.div(b);	//qn+1=an/bn
			a=b;		//an+1=bn
			b=q[1];		//bn+1=rest(an/bn)
			
			temp=u;		//temp=un
			u=s.sub(q[0].mult(u));	//un+1=sn-(qn+1*un)
			s=temp;		//sn+1=un
			
			temp=v;		//temp=vn
			v=t.sub(q[0].mult(v));	//vn+1=tn-(qn+1*vn)
			t=temp;		//tn+1=vn
			
			
		}catch (Exception e){ System.out.println("Fehler in gcd: "+e);}
		//debug Ausgabe:
		debug(2,"Erg. der "+i+"ten Iteration:---------------------------------------------------");
		debug(2,"a:"+a+"\r\nb:"+b+"\r\ns:"+s+"\r\nu:"+u+"\r\nt:"+t+"\r\nv:"+v+"\r\nq:"+q[0]+q[1]+"\r\n");
		debug(2,"End "+i+"te Iteration:----------------------------------------------------\r\n");
		i++;			
		
		
		}//end (!b.zero)
		
		debug(3,"<Ergebnis>:----------------------------------------");
		debug(3,"a:"+a+"\r\nb:"+b+"\r\ns:"+s+"\r\nu:"+u+"\r\nt:"+t+"\r\nv:"+v);
		debug(3,"</Ergebnis>:----------------------------------------\r\n");
			
		ret[0]=a.trim();
		ret[1]=s.trim();
		ret[2]=t.trim();
		return ret;
	}
	
  	public String toString(){
  		
  		String t="[";
		for(Iterator it=vars.iterator();it.hasNext();)
			t+=(Variable)it.next();
			
		return t+"]";
  	}
  	private boolean zero(){		//iss leer?
  		this.trim();
  		return vars.isEmpty();
  	}
  	public Polynom diff(){
  		Polynom ret=new Polynom();
  		for(Iterator it=vars.iterator();it.hasNext();)
			ret.vars.addElement(((Variable)it.next()).diff());
		return ret.trim();
	}
	public Polynom integr(){
  		Polynom ret=new Polynom();
  		for(Iterator it=vars.iterator();it.hasNext();)
			ret.vars.addElement(((Variable)it.next()).integr());
		return ret.trim();
	}
	public float eval(float e){
		float ret=0;
		for(Iterator it=vars.iterator();it.hasNext();)
			ret+=(((Variable)it.next()).eval(e));
		return ret;
	}
  	public Object CloneSer()		//clont ein Objeckt mit Hilfe von Serialize (voll genial)
   	 {
   		try{	
     		//Serialisieren des Objekts
     		ByteArrayOutputStream out = new ByteArrayOutputStream();
     		ObjectOutputStream os = new ObjectOutputStream(out);
     		os.writeObject(this);
     		os.flush();
     		//Deserialisieren des Objekts
     		ByteArrayInputStream in = new ByteArrayInputStream(
   	    	out.toByteArray()
   	  	);
   	  	ObjectInputStream is = new ObjectInputStream(in);
  	   	Object ret = is.readObject();
  	   	is.close();
  	   	os.close();
   	  	return ret;
   	  	
   		}catch(Exception e){ System.out.println("fehler beim Serialisieren aufgetreten:"+e);}
  	
  		return null;
  	}

  	
}