import java.io.*;
import java.util.*;

class Variable implements Serializable,Comparable{
	public float coeff;
	public int exp;
	
	public Variable(){
		coeff=0;
		exp=0;
	}
	
	public Variable(float c, int i){
		coeff=c;
		exp=i;
	}
	public void addmy(Variable v){
		if (exp==v.exp)	coeff+=v.coeff;		
	}
	public Variable add(Variable v){
		if (exp==v.exp)
			return new Variable(coeff+v.coeff,exp);
		else return null;
	}
	public Variable mult(Variable v){
		return new Variable (coeff*v.coeff,exp+v.exp);
	}
	public Variable div(Variable v){
		return new Variable(coeff/v.coeff,exp-v.exp);
	}
	public Variable diff(){
		return new Variable(coeff*exp,exp-1);
	}
	public Variable integr(){
		return new Variable(coeff/(exp+1),exp+1);
	}
	public float eval(float i){
		return coeff*((float)Math.pow(i,exp));
	}
	public Variable parse(String s){
		int i,j;
		float a;
		try{
			if ((a=(new Float(s)).floatValue()) !=0) return new Variable(a,0);
		}catch(NumberFormatException e){ }
		try{
			if ((i=s.indexOf("x"))!=-1){
				if ((a=new Float(s.substring(0,i)).floatValue()) !=0){
					if ((i+1)==s.length()) return new Variable(a,1);
					else if (s.charAt(i+1)=='^')
						if ((j=new Integer(s.substring(i+1,s.length()-1)).intValue()) !=0)
							return new Variable(a,j);
				}
			}
			return null;
				
		}catch(Exception e){ return null;}
	}
	public int compareTo(Object o){
		if (o instanceof Variable){
			int a;
			if (((a=((new Integer(exp)).compareTo((new Integer(((Variable)o).exp))))))==0 ) 
				return ((new Float(coeff)).compareTo((new Float(((Variable)o).coeff))) );
			else return a;
		}
		return 0;
	}
	public boolean equals(Object o){
		return (this.compareTo(o)==0);
	}
	public String toString(){
		String t="";
		if (coeff>=0) t="+";
		else if ((exp!=0)&&Math.round(coeff)==-1) t="-";
		if ((exp==0)||Math.abs(Math.round(coeff))!=1){
			if (coeff-(Math.round(coeff)) == 0) t+=(Math.round(coeff));
			else t+=coeff;
		}
		return ( t+(exp==0?"":((exp==1?"x":"x^"+exp))));
	}
}