/** Programm zur Verwaltung von Personen
  * @author Vitus Lorenz-Meyer
  * @version 1.2a vom 20.4 2002
  */
/**Klasse, die eine Liste von Personen reprsentiert */
import BTVisitor;
import java.io.*;

class Personen implements Adressbuch{
	public BinaryTree liste;
	protected int laenge;
	
	public Personen(){
		liste = new BinaryTree();
		laenge=0;
	}
	public Personen(BinaryTree tr){
		liste = tr;
		laenge=liste.length();
	}
	public void addPerson(Person_voll per) throws AdressBuchException{
		try{
			liste.insert(((Object)per.getName()+","+per.getVorname()),per);
			laenge++;
		}
		catch(RuntimeException e){
			laenge--;
			throw new AdressBuchException("Exception in addPerson->" + e.toString());
			
		}
	}
	
	public int anzahl(){
		if (liste.length()!=laenge) System.out.println("this.laenge inkonsisten zu BT.length!!!, correcting");
		return (laenge=liste.length());
	}
	
	
	public void personenLoeschen(){
		liste = new BinaryTree();
		laenge=0;
	}
	/** lscht eine Person aus der Liste
	*/
	public void personLoeschen(String vn, String n) throws AdressBuchException{
		BinaryTree a;
		if (!liste.isIn(n+","+vn)){
			throw new AdressBuchException("personLschen: Person nicht in Liste vorhanden!");
			
		}else{
			try{  a=liste.delete(n+","+vn);
				laenge--;
			}catch(RuntimeException e){
				laenge++;
				throw new AdressBuchException("Exception in personLschen->" + e.toString());
				
			}
			liste=a;
		}
	}
	
	
	public boolean enthaeltPerson(String vn, String n){
		return liste.isIn(n+","+vn);
	}
	public Adressbuch personAusgeben(String nachname) throws AdressBuchException{
		SearchVisitor v = new SearchVisitor(null,nachname);
		try{
			liste.acceptPre((BTVisitor)v);
		}catch(RuntimeException e){
			throw new AdressBuchException("Exception in personAusgeben->" + e.toString());
		}			
		return new Personen(v.tree);
	}
	/*
	public void printhtm() throws AdressBuchException{
		PrintHTMLVisitor v = new PrintHTMLVisitor(liste.high);
		
		try{
			for (int i=0;i<=liste.high;i++){
				v.visitBTStart(liste);
				liste.acceptLevel((BTVisitor)v,i);					
				v.visitBTEnd(liste);
			}
			v.output();
		}catch(RuntimeException e){
			throw new AdressBuchException("Exception in printHTML->" + e.toString());
		}
		
		
	}	
	*/	
	public Adressbuch suche(String muster) throws AdressBuchException{
		SearchVisitor v = new SearchVisitor(muster,null);
		try{
			liste.acceptPre((BTVisitor)v);
		}catch(RuntimeException e){
			throw new AdressBuchException("Exception in suche->" + e.toString());
		}return new Personen(v.tree);
	}	
	public String toString(){
		return liste.toString();
	}
	public String htmlString(){
		return liste.htmlString();
	}
	public void serialize(String filename){
		try {
        		BufferedWriter f2 = new BufferedWriter(new FileWriter(filename));
        		f2.write(this.toString());
         	
       		f2.close();
       
    		} catch (IOException e) {
      			System.out.println("Fehler beim fnen/Erstellen der Datei");
    		}
    	}
    	public void readFromFile(String filename) throws AdressBuchException{
    		try {	String line;
    			String[] ar = new String[8];
    			int j,i,k=0;
    			boolean breaky;
			BufferedReader f = new BufferedReader(
           		  new FileReader(filename));
       			while ((line = f.readLine()) != null){
       				j=0;breaky=false;
         			for (i=0; i<8; i++){
         				
         				if (-1 == (j=line.indexOf('#'))){ 
         					if (-1 == (j=line.indexOf('*'))){
         						System.out.println("broke bei"+i+","+k+"teZeile");
         						break;
         					}
         					else if (i<7) breaky=true;
         				}
         				ar[i] = (line.substring(0,j)).trim();
         				line=line.substring(j+1);
         				if (breaky) break;
         				    				
         			}
         			System.out.println("line "+k+" parsed, "+i+" Elements found<br>");
         			addPerson(new Person_voll(ar,i+1));
         			System.out.println("Person " + ar[0]+" read from file and added<br>");		         			         				
       				k++;
       			}
       			f.close();
     		} catch (IOException e) {
       		System.out.println("Fehler beim Lesen der Datei");
		}
	}

}
