(define l (list "CM" "D" "CD" #\C "XC" "L" "XL" #\X "IX" "V" "IV" #\I "" "" "" ""))
(define (rec x erg val lst) 
	(cond	( (= val 0) erg)
	      	( (or (= x (* val 9)) (> x (* val 9))) (rec (- x (* val 9)) (string-append erg (car lst)) (quotient val 10) (list-tail lst 4)) )
		( (= x (* val 5)) (rec (- x (* val 5)) (string-append erg (list-ref lst 1)) (quotient val 10) (list-tail lst 4)) )
		( (> x (* val 5)) (rec (- x (* val 5)) (string-append erg (list-ref lst 1)) val lst) )
		( (or (= x (* val 4)) (> x (* val 4))) (rec (- x (* val 4)) (string-append erg (list-ref lst 2)) (quotient val 10) (list-tail lst 4)) )
		( (or (= x (* val 1)) (> x (* val 1))) (rec (remainder x (* val 1)) (string-append erg (make-string (quotient x (* val 1)) (list-ref lst 3))) (quotient val 10) (list-tail lst 4)) )
		(else (rec x erg (quotient val 10) (list-tail lst 4)))
	)
)
(define (dec->rom x) (cond	( (> x 3999) (display "value over 3999 not allowed") )
				( (or (> x 1000) (= x 1000)) (rec (remainder x 1000) (make-string (quotient x 1000) #\M) 100 l) )		
				(else (rec x "" 100 l) )
		     )
)
;----------------------------------------------------------------------------------------
(define alist '((#\M 1000) (#\D 500) (#\C 100) (#\L 50) (#\X 10) (#\V 5) (#\I 1)))
(define (rom->dec x) 
		(cond ( (or (not (string? x)) (eqv? "" x)) (display "illegal input") )
		      (else (let ( (a (lrom->ldec (string->list (string-upcase x)) (list)) ) )
		      	         (if (eqv? a #f) (display "kein rmischer Buchstabe") (rom a 0))
		      	    )
		      )
		)
) 
(define (lrom->ldec x y) (if (null? x) y
				(if (not (eqv? #f (assv (car x) alist))) (lrom->ldec (cdr x) (append y (cdr (assv (car x) alist)))) 
				 #f)
			)
)
(define (rom l erg) (cond ( (null? l) erg )
			  ( (= (length l) 1) (+ erg (car l)) )
			  ( (< (car l) (list-ref l 1)) (rom (list-tail l 2) (+ erg (- (list-ref l 1) (car l)))) )
			  (else (rom (cdr l) (+ erg (car l))) )
			
		    )
)
;----------------------------------------------------------------------------------------	

(define (check) 

  ;*********************************************************************************
  ;*Funktionsname: check-rec                                                       *
  ;*Rckgabewert : unbestimmt                                                      *
  ;*Parameter    : x (int)                                                         *
  ;*x luft von 1 bis 3999, wird von arabic->roman in eine rmische Zahl umgewan-  *
  ;*delt, dann von roman->arabic in einen integer zurckgewandelt und mit dem ur-  *
  ;*sprnglichen x verglichen. Ist das Ergebnis nicht gleich x, wird x ausgegeben. *
  ;*********************************************************************************

  (define (check-rec x)
    (if (not (= x (rom->dec (dec->rom x)))) (begin (display x) (newline)))
    (if (< x 3999) (check-rec (+ x 1)))
  )
  (check-rec 1)
  (display "Diese Funktion berprft fr alle ganzen Zahlen x zwischen 1 und 3999 den Term")
  (newline)
  (display "      (= roman->arabic (arabic->roman x))")
  (newline)
  (display "Oben werden die Zahlen angegeben, fr die dies #f liefert. Es sollten keine sein.")
  (newline)  
)