import java.awt.*;
import java.awt.event.*;
/** Kleine Hilfsklasse, die einen Listener fr Window Ereignisse kapselt
  * es interessiert uns hier eigentlich nur close-Ereignise, hence the name
  * @version 1.0
  * @author Markus Burger-Scheidlin 2683838
  *         Vitus Lorenz-Meyer 2691370
  */
public class WindowClosingAdapter
extends WindowAdapter
{
  private boolean exitSystem;

  /**
   * Erzeugt einen WindowClosingAdapter zum Schliessen 
   * des Fensters. Ist exitSystem true, wird das komplette
   * Programm beendet.
   */
  public WindowClosingAdapter(boolean exitSystem)
  {
    this.exitSystem = exitSystem;
  }
  
  /**
   * Erzeugt einen WindowClosingAdapter zum Schliessen 
   * des Fensters. Das Programm wird nicht beendet.
   */
  public WindowClosingAdapter()
  {
    this(true);
  }
  /** wird aufgerugen, wenn das Fenster geschlossen werden soll
  * @param event ist ein Event Object, das besagt, was passiert ist
  */
  public void windowClosing(WindowEvent event)
  {
    event.getWindow().setVisible(false);
    event.getWindow().dispose();
    if (exitSystem) {
      System.exit(0);
    }
  }
}