import java.util.*;
import java.io.*;
/** Simuliert ein Woerterbuch unter Verwendung der Java-Klasse TreeSet, die
  * in der Bibliothek java.util.SortedSet zu finden ist.
  * @version 1.0
  * @author Markus Burger-Scheidlin 2683838
  *         Vitus Lorenz-Meyer 2691370
  */
public class Woerterbuch implements wbuch {
	
	/** Java-Tree Klasse aus java.util.sortedSet
	  */
	TreeSet Baum;
	
	/** Erzeugt ein neues Woerterbuch, indem ein Baum erzeugt wird.
	  */
	Woerterbuch() {
		Baum = new TreeSet();
	}
	
	/** Fgt dem Wrterbuch ein Wort hinzu.
	  * @param word Das Wort, das hinzugefgt werden soll
	  * @exception IllegalArgumentException wird ausgelst, wenn es sich um
	  *                                     ein ungltiges Eingabewort handelt.
	  */
	public void addWord(String word) throws IllegalArgumentException {
		// Eingabeberprfung zum werfen der Fehlermeldung
		Baum.add(word);
	}


	/** Lscht ein Wort aus dem Wrterbuch
	  * @param word Das Wort, das gelscht werden soll
	  * @exception IllegalArgumentException wird ausgelst, wenn es sich um
	  *                                     ein ungltiges Eingabewort handelt.
	  * @return true bei Erfolg, sonst false
	  */
	public boolean removeWord(String word) throws IllegalArgumentException {
		// Eingabeberprfung zum werfen der Fehlermeldung
		return Baum.remove(word);
	}


	/** berprft, ob ein Wort im Wrterbuch vorhanden ist.
	  * @param word Das Wort, das berprft wird
	  * @exception IllegalArgumentException wird ausgelst, wenn es sich um
	  *                                     ein ungltiges Eingabewort handelt.
	  * @return true, wenn das Wort im Wrterbuch enthalten ist, sonst false
	  */
	public boolean checkWord (String word) throws IllegalArgumentException {
		// Eingabeberprfung zum werfen der Fehlermeldung
		return Baum.contains(word);
	}


	/** Liest das Wrterbuch aus einem Textfile ein.
		Format:
		Wort1
		Wort2
		Wort3
		...
	  * @param filename Der Name des Textfiles
	  * @exception IOException tritt auf, wenn beim Lesen ein Fehler
	  *						   aufgetreten ist.
	  *            FileNotFoundException tritt auf, wenn das Textfile nicht
	  *                                  gefunden wurde
	  */
	public int readFromFile(String filename) throws IOException,
	                                          FileNotFoundException {
		String line;
		int i=0;
		// ein neuer BufferedReader wird erzeugt.
		BufferedReader br = new BufferedReader(new FileReader(filename));
		// Das File wird Zeile fr Zeile gelesen.		
		while ((line = br.readLine()) != null) {
			Baum.add(line);
			i++;
		}
		// Der FileReader wird wieder geschlossen.
		br.close();
		return i;
	}


	/** Schreibt das Wrterbuch in ein Textfile
		Format:
		Wort1
		Wort2
		Wort3
		...
      * @param filename Der Name des Textfiles
	  * @exception IOException tritt auf, wenn beim Lesen ein Fehler
	  *						   aufgetreten ist.
      */
	public void writeToFile(String filename) throws IOException {
		// Der Iterator des Baums wird zwischengespeichert
		Iterator it = Baum.iterator();
		// Der Filewriter wird erzeugt .
		FileWriter fw = new FileWriter(filename);
		// Der komplette Baum wird durchgegangen und geschrieben.
		while (it.hasNext()) {
			fw.write((String)it.next() + System.getProperty("line.separator"));
			// it = it.next();
		}
		// FileWriter wird geschlossen.
		fw.close();
	}
	public String toString(){
		return Baum.toString();
	}
}	