import java.util.*;
import java.io.*;
/** Interface, welches die Schnittstelle des Wrterbuchs definiert
  * @version 1.0
  * @author Markus Burger-Scheidlin 2683838
  *         Vitus Lorenz-Meyer 2691370
  */
interface wbuch {
	/** Fgt dem Wrterbuch ein Wort hinzu.
	  * @param word Das Wort, das hinzugefgt werden soll
	  * @exception IllegalArgumentException wird ausgelst, wenn es sich um
	  *                                     ein ungltiges Eingabewort handelt.
	  */
	public void addWord(String word) throws IllegalArgumentException;

	/** Lscht ein Wort aus dem Wrterbuch
	  * @param word Das Wort, das gelscht werden soll
	  * @exception IllegalArgumentException wird ausgelst, wenn es sich um
	  *                                     ein ungltiges Eingabewort handelt.
	  * @return true bei Erfolg, sonst false
	  */
	public boolean removeWord(String word) throws IllegalArgumentException;

	/** berprft, ob ein Wort im Wrterbuch vorhanden ist.
	  * @param word Das Wort, das berprft wird
	  * @exception IllegalArgumentException wird ausgelst, wenn es sich um
	  *                                     ein ungltiges Eingabewort handelt.
	  * @return true, wenn das Wort im Wrterbuch enthalten ist, sonst false
	  */
	public boolean checkWord (String word) throws IllegalArgumentException;

	/** Liest das Wrterbuch aus einem Textfile ein.
		Format:
		Wort1
		Wort2
		Wort3
		...
	  * @param filename Der Name des Textfiles
	  * @exception IOException tritt auf, wenn beim Lesen ein Fehler
	  *						   aufgetreten ist.
	  *            FileNotFoundException tritt auf, wenn das Textfile nicht
	  *                                  gefunden wurde
	  */
	public int readFromFile(String filename) throws IOException,
	                                          FileNotFoundException;

	/** Schreibt das Wrterbuch in ein Textfile
		Format:
		Wort1
		Wort2
		Wort3
		...
      * @param filename Der Name des Textfiles
	  * @exception IOException tritt auf, wenn beim Lesen ein Fehler
	  *						   aufgetreten ist.
      */
	public void writeToFile(String filename) throws IOException;
}