/** Programm zur Verwaltung von Personen
  * @author Vitus Lorenz-Meyer
  * @version 2.0 vom 26.5.2002:
  	- Elemente nun in binrem Suchbaum
  	- Suchbaum stellt accept fr visitor Interface zur Verfgung (In-,Pre-,Post- und LevelOrder)
  	- BTVisitor Interface definiert 3 Methoden zum visiten eines Baumes, wird immer mit der aktuellen Node aufgerufen, start,end und visitNode
  	- I/O Implementiert
        - serialisiert formatiert nach einer Datei 
        - liest Datenstze aus einer Datei getrennt durch #
        - AdressBuchException hinzugefgt, die Fehler anzeigt und abgefangen werden kann
        - Felder fr Telefonnummer und Hausnummernzusatz zu Person hinzugefgt
        - htmlString() zu jeder Klasse hinzugefgt, gibt einen String formatiert fr HTML Ausgabe
  	
  * history:
  -----------
      version 1.5 vom 1.5 2002:
  	- Klasse Person erweitert um Strae,Hausnummer,PLZ und Ort
  	- Person wirft eine IllegalArgumentException, falls ein Parameter falsch
  	- toString liefert eine Person nun formatiert wie eine Adresse
  	- Elemente nun in einer sortierten linearen Liste gespeichert
  	- Lnge der Liste,sowie Kopf- und Schwanzzeiger in Personen aufgenommen
  	- personAusgeben() liefert alle Personen mit dem gleichen Nachnamen
  	- Interface Adressbuch definiert, wird von Personen implemenetiert
      version 1.0 vom 18.4.2002:
	- erste Version, Person enthlt nur Vor- und Nachname
	- Elemente werden in einer linear, einfach verketteten Liste gespeichert
	- implementiert toString, sowie eine Suche
  */
/**Interface fr ein Adressbuch */
public interface Adressbuch{

        /** fgt eine Person hinzu 
        @param Person zum hunzufgen
        */
	public void addPerson(Person_voll per) throws AdressBuchException;

	/** gibt die Anzahl der Personen im Buch 
        @return die Anzahl der Personen
        */
	public int anzahl();

        /** lscht eine Person 
        @param string nachname,vorname*/
	public void personLoeschen(String vorname, String nachname) throws AdressBuchException;

	/** lscht alle Personen 
        */
	public void personenLoeschen();

        /** schaut ob eine bestimmte Person vorhanden 
        @param string vorname,nachname
        @return bool
        */
	public boolean enthaeltPerson(String vorname, String nachname);

        /** gibt wieder ein Adressbuch zurck mit allen gesuchten Personen 
        @return Adressbuch
        @param string nachname
        */
	public Adressbuch personAusgeben(String nachname) throws AdressBuchException;

        /** durchsucht das ganze Buch nach einem Musterstring 
        @return Adressbuch
        @param string Muster
        */
	public Adressbuch suche(String muster) throws AdressBuchException;
}
