/** Programm zur Verwaltung von Personen
  * @author Vitus Lorenz-Meyer
  * @version 2.0 vom 26.5.2002:
  	- Elemente nun in binrem Suchbaum
  	- Suchbaum stellt accept fr visitor Interface zur Verfgung (In-,Pre-,Post- und LevelOrder)
  	- BTVisitor Interface definiert 3 Methoden zum visiten eines Baumes, wird immer mit der aktuellen Node aufgerufen, start,end und visitNode
  	- I/O Implementiert
        - serialisiert formatiert nach einer Datei 
        - liest Datenstze aus einer Datei getrennt durch #
        - AdressBuchException hinzugefgt, die Fehler anzeigt und abgefangen werden kann
        - Felder fr Telefonnummer und Hausnummernzusatz zu Person hinzugefgt
        - htmlString() zu jeder Klasse hinzugefgt, gibt einen String formatiert fr HTML Ausgabe
  	
  * history:
  -----------
      version 1.5 vom 1.5 2002:
  	- Klasse Person erweitert um Strae,Hausnummer,PLZ und Ort
  	- Person wirft eine IllegalArgumentException, falls ein Parameter falsch
  	- toString liefert eine Person nun formatiert wie eine Adresse
  	- Elemente nun in einer sortierten linearen Liste gespeichert
  	- Lnge der Liste,sowie Kopf- und Schwanzzeiger in Personen aufgenommen
  	- personAusgeben() liefert alle Personen mit dem gleichen Nachnamen
  	- Interface Adressbuch definiert, wird von Personen implemenetiert
      version 1.0 vom 18.4.2002:
	- erste Version, Person enthlt nur Vor- und Nachname
	- Elemente werden in einer linear, einfach verketteten Liste gespeichert
	- implementiert toString, sowie eine Suche
  */
/**Klasse, die eine einzelne Person reprsentiert */
class Person implements Comparable{
	/** Name und Nachname */
	protected String name, vorname;
    	/** leerer Konstruktor */
	
	public Person(){
		name="";
		vorname="";
	}
       
        /** Konstruktor */
        public Person(String N,String Vn){
		name = N;
		vorname = Vn;
	}
        /** gibt den Namen
        *@return Name
         */
	public String getName(){ 
		return name;
	}
        /** gibt den Vornamen
        *@return Vorname
         */
	public String getVorname(){
		return vorname;
	}
        /** gibt die Person als String aus 
        @return String
        */
	public String toString(){
		return (String)(vorname + " " + name);
	}
        /** vergleicht this mit einem gegeben Object
        @int kleiner oder grer
        @throws exception wenn nicht Person
         */
	public int compareTo(Object o){
		if (o instanceof Person){
			int ret;
			if ((ret=((Person)o).getName().compareTo(name))==0)
				return -((Person)o).getVorname().compareTo(vorname);
			else return -ret;
		}
		else throw new IllegalArgumentException("Person kann nur mit einer Person verglichen werden!");
	}
	
	/** Iss this gleich mit einem gegeben Object
        @boolean
        @throws Exception, wenn nicht Person
         */
	public boolean equals(Object o){
		if (o instanceof Person){
			boolean ret;
			if ((ret=((Person)o).getName().equals(name))==true)
				return ((Person)o).getVorname().equals(vorname);
			else return ret;
		}
		else throw new IllegalArgumentException("Person kann nur mit einer Person verglichen werden!");
	}
}
